PRINT ""
PRINT "BATCH-TESTING.  COPYRIGHT MICHAEL KORENBERG, 1995."
PRINT "USE THIS PROGRAM TO CLASSIFY TEST DATA SEQUENCES."
PRINT "USES 200 SAMPLES, STARTING 50 SAMPLES BEFORE MOVING AVERAGE > 100 mV"
PRINT " "
PRINT "PROGRAM REQUIRES 'PARALIN.DAT' CONTAINING LINEAR SYSTEMS OF THE"
PRINT "CASCADES, AND 'PARAPOLY.DAT' CONTAINING THE STATIC NONLINEARITIES."
PRINT " "
PRINT "PROGRAM ALSO REQUIRES THE EMG DATA FILES TO BE CLASSIFIED,"
PRINT "  AND A FILE LISTING THE NAMES OF THE DATA FILES TO BE CLASSIFIED."
PRINT " "
INPUT "NAME OF FILE LISTING DATA FILES TO BE CLASSIFIED";A$
INPUT "NAME OF FILE TO STORE CLASSIFICATION RESULTS (1 = GOOD, -1 = BAD)";E$
DEFINT N,R,I,J
DEFDBL A,C,D,H,P,S,X,Y,Z,E
INPUT "IDEAL VALUE OF CLASSIFIER: 1 OR -1";IDEAL
INPUT "NUMBER OF CASCADES";NUM
OPEN "PARALIN.DAT" FOR INPUT AS #1:INPUT #1,C$:INPUT #1,R:RR=R-1:CLOSE #1
OPEN "PARAPOLY.DAT" FOR INPUT AS #2:INPUT #2,C$:INPUT #2,ND:CLOSE #2
INPUT "DO YOU WANT PRINTOUT (Y / N)";D$
DIM H(RR),CC(ND),X(1000),Y(1000),Z(1000)
IF D$= "Y" THEN LPRINT " "
IF D$="Y" THEN LPRINT A$
PRINT " "
PRINT A$
IF D$="Y" THEN LPRINT "TRAINING DATA: ";C$
IF D$="Y" THEN LPRINT "MEMORY (TOTAL NUMBER OF INPUT LAGS, INCLUDING 0) =";R
IF D$="Y" THEN LPRINT "POLYNOMIAL DEGREE =";ND
IF D$="Y" THEN LPRINT "NUMBER OF CASCADES USED =";NUM
OPEN E$ FOR OUTPUT AS #4
OPEN A$ FOR INPUT AS #5
NW=0:NTO=0
2 INPUT #5,B$:NTO=NTO+1
OPEN B$ FOR INPUT AS #1
S1=0
FOR I=1 TO 100
INPUT #1,XX1
S1=S1+ABS(XX1)
NEXT I:S1=S1/100
CLOSE #1
OPEN B$ FOR INPUT AS #1
NN1=0
FOR I=1 TO 1000
INPUT #1,X(I)
IF I > 100 THEN S1=S1+(ABS(X(I))-ABS(X(I-100)))/100
IF NN1 > 1 THEN GOTO 222
IF I > 99 AND S1 > 100 THEN NST1=I-50:NN1=2
222 NEXT I
CLOSE #1
NFI1=NST1+199
NST1=NST1+RR
OPEN B$ FOR INPUT AS #1
FOR I=0 TO 999
INPUT #1,X(I)
NEXT I
CLOSE #1
T1=999
OPEN "PARALIN.DAT" FOR INPUT AS #1:INPUT #1,C$:INPUT #1,R:RR=R-1:RRR=R-2
OPEN "PARAPOLY.DAT" FOR INPUT AS #2:INPUT #2,C$:INPUT #2,ND
FOR N=0 TO T1
Z(N)=0
NEXT N
'COMPUTE OUTPUT OF EACH CASCADE
FOR I=1 TO NUM
FOR J=0 TO RR
INPUT #1,II,JJ,H(JJ)
IF I <> II THEN PRINT "ERROR IN READING 'PARALIN.DAT'"
NEXT J
FOR J=0 TO ND
INPUT #2,IN,JJ,CC(JJ)
IF I <> IN THEN PRINT "ERROR IN READING 'PARAPOLY.DAT'.":GOTO 100
NEXT J
FOR N=RR TO T1:D=0
FOR R1=0 TO RR
D=D+H(R1)*X(N-R1)
NEXT R1
E=0
FOR J=0 TO ND
E=E+CC(J)*D^J
NEXT J
Z(N)=Z(N)+E
NEXT N
NEXT I
CLOSE #2:CLOSE #1
DIF=0
CNS1=0:NP1=0
RRRP1=RRR+1
FOR N=RRRP1 TO T1
ZN=Z(N)
IF N >= NST1 AND N <= NFI1 THEN CNS1=CNS1+ZN:NP1=NP1+1:DIF=DIF+(ZN-IDEAL)^2
NEXT N
IF NP1 = 0 THEN GOTO 195
DIF=DIF/NP1
ANS1=CNS1/NP1
P1=100*DIF
IF IDEAL = 1 THEN GOTO 999
IF ANS1 < 0 THEN BB$="  SEQUENCE CLASSIFIED CORRECTLY"
IF ANS1 > 0 THEN BB$="  SEQUENCE MISCLASSIFIED":P1=100*(DIF-4*ANS1):NW=NW+1
IF ANS1 < 0 THEN PRINT #4,B$,1 ELSE PRINT #4,B$,-1
GOTO 1002
999 IF ANS1 > 0 THEN BB$="  SEQUENCE CLASSIFIED CORRECTLY"
IF ANS1 < 0 THEN BB$="  SEQUENCE MISCLASSIFIED":P1=100*(DIF+4*ANS1):NW=NW+1
IF ANS1 > 0 THEN PRINT #4,B$,1 ELSE PRINT #4,B$,-1
1002 IF D$="Y" THEN LPRINT " "
PRINT " "
PRINT "    AVERAGE PARALLEL CASCADE OUTPUT =";ANS1
PRINT "% MSE FROM CHOSEN CLASS =";P1
IF D$="Y" THEN LPRINT B$;BB$
PRINT B$;BB$
IF D$="Y" THEN LPRINT "    AVERAGE PARALLEL CASCADE OUTPUT = ";ANS1
IF D$="Y" THEN LPRINT "% MSE FROM CHOSEN CLASS = ";P1
195 IF EOF(5) THEN GOTO 200 ELSE GOTO 2
200 CLOSE #5
CLOSE #4
IF D$="Y" THEN LPRINT " "
IF D$="Y" THEN LPRINT NW;" SEQUENCES WERE MISCLASSIFIED OUT OF A TOTAL OF";NTO
PRINT " "
PRINT NW;" SEQUENCES WERE MISCLASSIFIED OUT OF A TOTAL OF";NTO
PRINT A$
PRINT "TRAINING DATA: ";C$
IF D$="Y" THEN LPRINT " "
100 END